_float_to_string:

_lpSrc equ 0x8
_scientificflag equ 1
_lpDest equ -4
_uID equ _lpDest - 4
_tempdw equ _uID - 4
_esize equ _tempdw - 4
_Decimal equ _esize - 4
_bcdstr equ _Decimal - 10
_oldcw equ _bcdstr - 2
_unpacked equ _oldcw - 20
_truncw equ _unpacked - 4

	push ebp
	mov ebp,esp
	sub esp,-_truncw

	; ...Alloc string here...
	mov [ebp+_lpDest],eax

	mov dword [ebp+_uID],0
	mov dword [ebp+_Decimal],7
	finit
	fld dword [ebp+_lpSrc]
	jmp _dest0
_srcerr:
	push edi
	mov edi,[ebp+_lpDest]
	mov eax,"ERRO"
	stosd
	mov ax,"R"
	stosw
	pop edi
	jmp _finish1
_dest0:
	fxam
	fstsw ax
	fwait
	sahf
	jz _maybezero
	jpo _srcerr
	jnc _getnumsize
	push ecx
	push esi
	push edi
	mov edi,[ebp+_lpDest]
	mov al,"+"
	test ah,2
	jz _putsign
	mov al,"-"
_putsign
	stosb
	mov eax,"IFNI"
	stosd
	mov eax,"YTIN"
	stosd
	jmp _finish
_maybezero:
	jc _srcerr
	jpe _getnumsize
	fstp st0
	push ecx
	push esi
	push edi
	mov edi,[ebp+_lpDest]
	mov al,0x30
	stosb
	jmp _finish
_getnumsize:
	fldlg2
	fld st1
	fabs
	fyl2x
	fstcw word [ebp+_oldcw]
	fwait
	mov ax,[ebp+_oldcw]
	or ax,0xc00
	mov [ebp+_truncw],ax
	fldcw word [ebp+_truncw]
	fist dword [ebp+_esize]
	fldcw word [ebp+_oldcw]
	ftst
	fstsw ax
	fwait
	sahf
	sbb dword [ebp+_esize],0
	fstp st0
	mov eax,[ebp+_esize]
	test eax,eax
	jns _positivelen
	cmp eax,-6
	jae _negativelen
	or dword [ebp+_uID],_scientificflag
	mov dword [ebp+_Decimal],6
	jmp _scific
_positivelen:
	cmp eax,6
	jbe _exp1016
	or dword [ebp+_uID],_scientificflag
	mov dword [ebp+_Decimal],6
	jmp _scific
_exp1016:
	add eax,[ebp+_Decimal]
	cmp eax,6
	jbe _negativelen
	sub eax,6
	sub [ebp+_Decimal],eax
_negativelen:
	push dword [ebp+_Decimal]
	pop dword [ebp+_tempdw]
	jmp _noscific
_scific:
	mov eax,[ebp+_Decimal]
	sub eax,[ebp+_esize]
	mov [ebp+_tempdw],eax
_noscific:
	cmp dword [ebp+_tempdw],0
	je _mulpow10
	fild dword [ebp+_tempdw]
	fldl2t
	fmulp st1,st0
	fld st0
	frndint
	fxch
	fsub st0,st1
	f2xm1
	fld1
	faddp st1,st0
	fscale
	fstp st1
	fmulp st1,st0
_mulpow10:
	fbstp [ebp+_bcdstr]
	fstsw ax
	fwait
	shr eax,1
	jc _srcerr
	push ecx
	push esi
	push edi
	lea esi,[ebp+_bcdstr+9]
	lea edi,[ebp+_unpacked]
	mov eax,0x3020
	mov cl,byte [esi]
	test cl,cl
	jns _nosign
	mov al,"-"
_nosign:
	stosw
	mov ecx,9
_copybcd:
	dec esi
	movzx eax,byte [esi]
	ror ax,4
	ror ah,4
	add ax,0x3030
	stosw
	dec ecx
	jnz _copybcd
	mov edi,[ebp+_lpDest]
	lea esi,[ebp+_unpacked]
	test dword [ebp+_uID],_scientificflag
	jnz _scientific
	lodsb
	cmp al,"-"
	jne _nosign_scient
	stosb
_nosign_scient:
	mov ecx,1
	mov eax,[ebp+_esize]
	test eax,eax
	js _negsize
	add ecx,eax
_negsize:
	mov eax,[ebp+_Decimal]
	add eax,ecx
	sub eax,19
	sub esi,eax
	cmp byte [esi-1],"1"
	jne _1digit
	dec esi
	inc ecx
_1digit:
	rep movsb
	mov ecx,[ebp+_Decimal]
	test ecx,ecx
	jz _nodecimal
	mov al,"."
	stosb
	rep movsb
_loop_remove_xtrazeros_std:
	cmp byte [edi-1],\"0\"
	jne _remove_xtrazeros_std
	dec edi
	jmp _loop_remove_xtrazeros_std
_remove_xtrazeros_std:
	cmp byte [edi-1],"."
	jne _nodecimal
	dec edi
_nodecimal:
	jmp _finish
_scientific:
	lodsb
	cmp al,"-"
	jne _nosign_noscient
	stosb
_nosign_noscient:
	mov ecx,[ebp+_Decimal]
	mov eax,18
	sub eax,ecx
	add esi,eax
	cmp byte [esi-1],"1"
	pushfd
	jnz _1digitb
	dec esi
_1digitb:
	movsb
	mov al,"."
	stosb
	rep movsb
_loop_remove_xtrazeros_sci:
	cmp byte [edi-1],"0"
	jne _remove_xtrazeros_sci
	dec edi
	jmp _loop_remove_xtrazeros_sci
_remove_xtrazeros_sci:
	cmp byte [edi-1],"."
	jne _remove_xtradot_sci
	dec edi
_remove_xtradot_sci:
	mov al,"E"
	stosb
	mov al,"+"
	mov ecx,[ebp+_esize]
	popfd
	jnz _extra1
	inc ecx
_extra1:
	test ecx,ecx
	jns _expsign
	mov al,"-"
	neg ecx
_expsign:
	stosb
	mov eax,ecx
	mov cl,100
	div cl
	push eax
	and eax,0xff
	mov cl,10
	div cl
	add ax,0x3030
	cmp al,0x30
	je _empty_exp1
	stosb
_empty_exp1:
	shr ax,8
	cmp al,0x30
	je _empty_exp2
	stosb
_empty_exp2:
	pop eax
	shr eax,8
	div cl
	add ax,0x3030
	cmp al,0x30
	je _empty_exp3
	stosb
_empty_exp3:
	shr ax,8
	cmp al,0x30
	je _finish
	stosb
_finish:
	xor eax,eax
	stosb
	pop edi
	pop esi
	pop ecx
_finish1:
	finit
	; ... [ebp+_lpDest] contains string...
	leave
	ret 4
